Index: protocols/oscar/chat.c
===================================================================
--- protocols/oscar/chat.c	(revision c2fb38096ea4e75a680e57e103d4a4986aa84c75)
+++ protocols/oscar/chat.c	(revision 84b045d409f1e8da6d8bf379c6fef7236dcd9bcd)
@@ -54,5 +54,5 @@
 			continue;
 		if (!cur->priv) {
-			imc_error(sess->aux_data, "chat connection with no name!");
+			imcb_error(sess->aux_data, "chat connection with no name!");
 			continue;
 		}
@@ -397,5 +397,5 @@
 
 	if (detaillevel != 0x02) {
-		imc_error(sess->aux_data, "Only detaillevel 0x2 is support at the moment");
+		imcb_error(sess->aux_data, "Only detaillevel 0x2 is support at the moment");
 		return 1;
 	}
@@ -615,5 +615,5 @@
 
 	if (channel != 0x0003) {
-		imc_error(sess->aux_data, "unknown channel!");
+		imcb_error(sess->aux_data, "unknown channel!");
 		return 0;
 	}
Index: protocols/oscar/chatnav.c
===================================================================
--- protocols/oscar/chatnav.c	(revision c2fb38096ea4e75a680e57e103d4a4986aa84c75)
+++ protocols/oscar/chatnav.c	(revision 84b045d409f1e8da6d8bf379c6fef7236dcd9bcd)
@@ -286,5 +286,5 @@
 
 	if (!(bigblock = aim_gettlv(tlvlist, 0x0004, 1))) {
-		imc_error(sess->aux_data, "no bigblock in top tlv in create room response");
+		imcb_error(sess->aux_data, "no bigblock in top tlv in create room response");
 	
 		aim_freetlvchain(&tlvlist);
@@ -301,5 +301,5 @@
 
 	if (detaillevel != 0x02) {
-		imc_error(sess->aux_data, "unknown detaillevel in create room response");
+		imcb_error(sess->aux_data, "unknown detaillevel in create room response");
 		aim_freetlvchain(&tlvlist);
 		g_free(ck);
@@ -367,10 +367,10 @@
 
 	if (!(snac2 = aim_remsnac(sess, snac->id))) {
-		imc_error(sess->aux_data, "received response to unknown request!");
+		imcb_error(sess->aux_data, "received response to unknown request!");
 		return 0;
 	}
 
 	if (snac2->family != 0x000d) {
-		imc_error(sess->aux_data, "recieved response that maps to corrupt request!");
+		imcb_error(sess->aux_data, "recieved response that maps to corrupt request!");
 		return 0;
 	}
@@ -389,5 +389,5 @@
 		ret = parseinfo_create(sess, mod, rx, snac, bs, snac2);
 	else
-		imc_error(sess->aux_data, "unknown request subtype");
+		imcb_error(sess->aux_data, "unknown request subtype");
 
 	if (snac2)
Index: protocols/oscar/icq.c
===================================================================
--- protocols/oscar/icq.c	(revision c2fb38096ea4e75a680e57e103d4a4986aa84c75)
+++ protocols/oscar/icq.c	(revision 84b045d409f1e8da6d8bf379c6fef7236dcd9bcd)
@@ -240,5 +240,5 @@
 	if (!(tl = aim_readtlvchain(bs)) || !(datatlv = aim_gettlv(tl, 0x0001, 1))) {
 		aim_freetlvchain(&tl);
-		imc_error(sess->aux_data, "corrupt ICQ response\n");
+		imcb_error(sess->aux_data, "corrupt ICQ response\n");
 		return 0;
 	}
Index: protocols/oscar/im.c
===================================================================
--- protocols/oscar/im.c	(revision c2fb38096ea4e75a680e57e103d4a4986aa84c75)
+++ protocols/oscar/im.c	(revision 84b045d409f1e8da6d8bf379c6fef7236dcd9bcd)
@@ -937,5 +937,5 @@
 
 	if (channel != 0x01) {
-		imc_error(sess->aux_data, "icbm: ICBM recieved on unsupported channel.  Ignoring.");
+		imcb_error(sess->aux_data, "icbm: ICBM recieved on unsupported channel.  Ignoring.");
 		return 0;
 	}
@@ -1345,5 +1345,5 @@
 
 		} else {
-			// imc_error(sess->aux_data, "Unknown TLV encountered");
+			// imcb_error(sess->aux_data, "Unknown TLV encountered");
 		}
 
@@ -1517,5 +1517,5 @@
 	cookie2 = aimbs_getraw(&bbs, 8);
 	if (memcmp(cookie, cookie2, 8) != 0) 
-		imc_error(sess->aux_data, "rend: warning cookies don't match!");
+		imcb_error(sess->aux_data, "rend: warning cookies don't match!");
 	memcpy(args.cookie, cookie2, 8);
 	g_free(cookie2);
@@ -1783,5 +1783,5 @@
 	} else {
 
-		imc_error(sess->aux_data, "ICBM received on an unsupported channel.  Ignoring.");
+		imcb_error(sess->aux_data, "ICBM received on an unsupported channel.  Ignoring.");
 
 		return 0;
Index: protocols/oscar/info.c
===================================================================
--- protocols/oscar/info.c	(revision c2fb38096ea4e75a680e57e103d4a4986aa84c75)
+++ protocols/oscar/info.c	(revision 84b045d409f1e8da6d8bf379c6fef7236dcd9bcd)
@@ -474,5 +474,5 @@
 			 */
 #ifdef DEBUG
-			// imc_error(sess->aux_data, G_STRLOC);
+			// imcb_error(sess->aux_data, G_STRLOC);
 #endif
 
@@ -635,5 +635,5 @@
 
 	if (!origsnac || !origsnac->data) {
-		imc_error(sess->aux_data, "major problem: no snac stored!");
+		imcb_error(sess->aux_data, "major problem: no snac stored!");
 		return 0;
 	}
@@ -644,5 +644,5 @@
 			(inforeq->infotype != AIM_GETINFO_AWAYMESSAGE) &&
 			(inforeq->infotype != AIM_GETINFO_CAPABILITIES)) {
-		imc_error(sess->aux_data, "unknown infotype in request!");
+		imcb_error(sess->aux_data, "unknown infotype in request!");
 		return 0;
 	}
Index: protocols/oscar/oscar.c
===================================================================
--- protocols/oscar/oscar.c	(revision c2fb38096ea4e75a680e57e103d4a4986aa84c75)
+++ protocols/oscar/oscar.c	(revision 84b045d409f1e8da6d8bf379c6fef7236dcd9bcd)
@@ -267,5 +267,5 @@
 			if ((conn->type == AIM_CONN_TYPE_BOS) ||
 				   !(aim_getconn_type(odata->sess, AIM_CONN_TYPE_BOS))) {
-				imc_error(ic, _("Disconnected."));
+				imcb_error(ic, _("Disconnected."));
 				imc_logout(ic, TRUE);
 			} else if (conn->type == AIM_CONN_TYPE_CHAT) {
@@ -277,5 +277,5 @@
 				c->fd = -1;
 				aim_conn_kill(odata->sess, &conn);
-				imc_error(sess->aux_data, _("You have been disconnected from chat room %s."), c->name);
+				imcb_error(sess->aux_data, _("You have been disconnected from chat room %s."), c->name);
 			} else if (conn->type == AIM_CONN_TYPE_CHATNAV) {
 				if (odata->cnpa > 0)
@@ -288,5 +288,5 @@
 						g_slist_remove(odata->create_rooms, cr);
 					g_free(cr);
-					imc_error(sess->aux_data, _("Chat is currently unavailable"));
+					imcb_error(sess->aux_data, _("Chat is currently unavailable"));
 				}
 				aim_conn_kill(odata->sess, &conn);
@@ -325,5 +325,5 @@
 
 	if (source < 0) {
-		imc_error(ic, _("Couldn't connect to host"));
+		imcb_error(ic, _("Couldn't connect to host"));
 		imc_logout(ic, TRUE);
 		return FALSE;
@@ -353,5 +353,5 @@
 	aim_session_t *sess;
 	aim_conn_t *conn;
-	struct im_connection *ic = imc_new(acc);
+	struct im_connection *ic = imcb_new(acc);
 	struct oscar_data *odata = ic->proto_data = g_new0(struct oscar_data, 1);
 
@@ -380,5 +380,5 @@
 	conn = aim_newconn(sess, AIM_CONN_TYPE_AUTH, NULL);
 	if (conn == NULL) {
-		imc_error(ic, _("Unable to login to AIM"));
+		imcb_error(ic, _("Unable to login to AIM"));
 		imc_logout(ic, TRUE);
 		return;
@@ -386,5 +386,5 @@
 	
 	if (acc->server == NULL) {
-		imc_error(ic, "No servername specified");
+		imcb_error(ic, "No servername specified");
 		imc_logout(ic, FALSE);
 		return;
@@ -393,8 +393,8 @@
 	if (g_strcasecmp(acc->server, "login.icq.com") != 0 &&
 	    g_strcasecmp(acc->server, "login.oscar.aol.com") != 0) {
-		imc_log(ic, "Warning: Unknown OSCAR server: `%s'. Please review your configuration if the connection fails.",acc->server);
-	}
-	
-	imc_log(ic, _("Signon: %s"), ic->acc->user);
+		imcb_log(ic, "Warning: Unknown OSCAR server: `%s'. Please review your configuration if the connection fails.",acc->server);
+	}
+	
+	imcb_log(ic, _("Signon: %s"), ic->acc->user);
 
 	aim_conn_addhandler(sess, conn, 0x0017, 0x0007, gaim_parse_login, 0);
@@ -404,5 +404,5 @@
 	conn->fd = proxy_connect(acc->server, AIM_LOGIN_PORT, oscar_login_connect, ic);
 	if (conn->fd < 0) {
-		imc_error(ic, _("Couldn't connect to host"));
+		imcb_error(ic, _("Couldn't connect to host"));
 		imc_logout(ic, TRUE);
 		return;
@@ -464,5 +464,5 @@
 
 	if (source < 0) {
-		imc_error(ic, _("Could Not Connect"));
+		imcb_error(ic, _("Could Not Connect"));
 		imc_logout(ic, TRUE);
 		return FALSE;
@@ -472,5 +472,5 @@
 	ic->inpa = b_input_add(bosconn->fd, GAIM_INPUT_READ,
 			oscar_callback, bosconn);
-	imc_log(ic, _("Connection established, cookie sent"));
+	imcb_log(ic, _("Connection established, cookie sent"));
 	
 	return FALSE;
@@ -495,21 +495,21 @@
 		case 0x05:
 			/* Incorrect nick/password */
-			imc_error(ic, _("Incorrect nickname or password."));
+			imcb_error(ic, _("Incorrect nickname or password."));
 //			plugin_event(event_error, (void *)980, 0, 0, 0);
 			break;
 		case 0x11:
 			/* Suspended account */
-			imc_error(ic, _("Your account is currently suspended."));
+			imcb_error(ic, _("Your account is currently suspended."));
 			break;
 		case 0x18:
 			/* connecting too frequently */
-			imc_error(ic, _("You have been connecting and disconnecting too frequently. Wait ten minutes and try again. If you continue to try, you will need to wait even longer."));
+			imcb_error(ic, _("You have been connecting and disconnecting too frequently. Wait ten minutes and try again. If you continue to try, you will need to wait even longer."));
 			break;
 		case 0x1c:
 			/* client too old */
-			imc_error(ic, _("The client version you are using is too old. Please upgrade at " WEBSITE));
+			imcb_error(ic, _("The client version you are using is too old. Please upgrade at " WEBSITE));
 			break;
 		default:
-			imc_error(ic, _("Authentication Failed"));
+			imcb_error(ic, _("Authentication Failed"));
 			break;
 		}
@@ -523,5 +523,5 @@
 	bosconn = aim_newconn(sess, AIM_CONN_TYPE_BOS, NULL);
 	if (bosconn == NULL) {
-		imc_error(ic, _("Internal Error"));
+		imcb_error(ic, _("Internal Error"));
 		od->killme = TRUE;
 		return 0;
@@ -569,5 +569,5 @@
 	g_free(host);
 	if (bosconn->fd < 0) {
-		imc_error(ic, _("Could Not Connect"));
+		imcb_error(ic, _("Could Not Connect"));
 		od->killme = TRUE;
 		return 0;
@@ -607,5 +607,5 @@
 	}
 	if (in != '\n') {
-		imc_error(pos->ic, "Gaim was unable to get a valid hash for logging into AIM."
+		imcb_error(pos->ic, "Gaim was unable to get a valid hash for logging into AIM."
 				" You may be disconnected shortly.");
 		b_event_remove(pos->inpa);
@@ -630,5 +630,5 @@
 
 	if (source < 0) {
-		imc_error(pos->ic, "Gaim was unable to get a valid hash for logging into AIM."
+		imcb_error(pos->ic, "Gaim was unable to get a valid hash for logging into AIM."
 				" You may be disconnected shortly.");
 		if (pos->modname)
@@ -708,5 +708,5 @@
 			g_free(pos->modname);
 		g_free(pos);
-		imc_error(sess->aux_data, "Gaim was unable to get a valid hash for logging into AIM."
+		imcb_error(sess->aux_data, "Gaim was unable to get a valid hash for logging into AIM."
 				" You may be disconnected shortly.");
 	}
@@ -1112,5 +1112,5 @@
 		inv->name = g_strdup(name);
 		
-		do_ask_dialog( ic, txt, inv, oscar_accept_chat, oscar_reject_chat);
+		imcb_ask( ic, txt, inv, oscar_accept_chat, oscar_reject_chat);
 	
 		if (name)
@@ -1130,5 +1130,5 @@
 	// aim_send_im_ch4(od->sess, uin, AIM_ICQMSG_AUTHGRANTED, &message);
 	if(find_buddy(data->ic, uin) == NULL)
-		show_got_added(data->ic, uin, NULL);
+		imcb_ask_add(data->ic, uin, NULL);
 	
 	g_free(uin);
@@ -1164,5 +1164,5 @@
 	data->ic = ic;
 	data->uin = uin;
-	do_ask_dialog(ic, dialog_msg, data, gaim_icq_authgrant, gaim_icq_authdeny);
+	imcb_ask(ic, dialog_msg, data, gaim_icq_authgrant, gaim_icq_authdeny);
 	g_free(dialog_msg);
 }
@@ -1207,9 +1207,9 @@
 
 		case 0x0007: { /* Someone has denied you authorization */
-			imc_log(sess->aux_data, "The user %u has denied your request to add them to your contact list for the following reason:\n%s", args->uin, args->msg ? args->msg : _("No reason given.") );
+			imcb_log(sess->aux_data, "The user %u has denied your request to add them to your contact list for the following reason:\n%s", args->uin, args->msg ? args->msg : _("No reason given.") );
 		} break;
 
 		case 0x0008: { /* Someone has granted you authorization */
-			imc_log(sess->aux_data, "The user %u has granted your request to add them to your contact list for the following reason:\n%s", args->uin, args->msg ? args->msg : _("No reason given.") );
+			imcb_log(sess->aux_data, "The user %u has granted your request to add them to your contact list for the following reason:\n%s", args->uin, args->msg ? args->msg : _("No reason given.") );
 		} break;
 
@@ -1277,5 +1277,5 @@
 		case 0:
 			/* Invalid (0) */
-			imc_error(sess->aux_data,
+			imcb_error(sess->aux_data,
 				   nummissed == 1 ? 
 				   _("You missed %d message from %s because it was invalid.") :
@@ -1286,5 +1286,5 @@
 		case 1:
 			/* Message too large */
-			imc_error(sess->aux_data,
+			imcb_error(sess->aux_data,
 				   nummissed == 1 ?
 				   _("You missed %d message from %s because it was too large.") :
@@ -1295,5 +1295,5 @@
 		case 2:
 			/* Rate exceeded */
-			imc_error(sess->aux_data,
+			imcb_error(sess->aux_data,
 				   nummissed == 1 ? 
 				   _("You missed %d message from %s because the rate limit has been exceeded.") :
@@ -1304,5 +1304,5 @@
 		case 3:
 			/* Evil Sender */
-			imc_error(sess->aux_data,
+			imcb_error(sess->aux_data,
 				   nummissed == 1 ?
 				   _("You missed %d message from %s because it was too evil.") : 
@@ -1313,5 +1313,5 @@
 		case 4:
 			/* Evil Receiver */
-			imc_error(sess->aux_data,
+			imcb_error(sess->aux_data,
 				   nummissed == 1 ? 
 				   _("You missed %d message from %s because you are too evil.") :
@@ -1321,5 +1321,5 @@
 			break;
 		default:
-			imc_error(sess->aux_data,
+			imcb_error(sess->aux_data,
 				   nummissed == 1 ? 
 				   _("You missed %d message from %s for unknown reasons.") :
@@ -1341,5 +1341,5 @@
 	va_end(ap);
 
-	imc_error(sess->aux_data, _("SNAC threw error: %s"),
+	imcb_error(sess->aux_data, _("SNAC threw error: %s"),
 	          reason < msgerrreasonlen ? msgerrreason[reason] : "Unknown error");
 
@@ -1357,5 +1357,5 @@
 	va_end(ap);
 
-	imc_error(sess->aux_data, _("Your message to %s did not get sent: %s"), destn,
+	imcb_error(sess->aux_data, _("Your message to %s did not get sent: %s"), destn,
 			(reason < msgerrreasonlen) ? msgerrreason[reason] : _("Reason unknown"));
 
@@ -1373,5 +1373,5 @@
 	va_end(ap);
 
-	imc_error(sess->aux_data, _("User information for %s unavailable: %s"), destn,
+	imcb_error(sess->aux_data, _("User information for %s unavailable: %s"), destn,
 			(reason < msgerrreasonlen) ? msgerrreason[reason] : _("Reason unknown"));
 
@@ -1390,5 +1390,5 @@
 
 	if (id < 4)
-		imc_error(sess->aux_data, _("Your connection may be lost."));
+		imcb_error(sess->aux_data, _("Your connection may be lost."));
 
 	return 1;
@@ -1584,5 +1584,5 @@
 		aim_conn_setlatency(fr->conn, windowsize/4);
 	} else if (code == AIM_RATE_CODE_LIMIT) {
-		imc_error(sess->aux_data, _("The last message was not sent because you are over the rate limit. "
+		imcb_error(sess->aux_data, _("The last message was not sent because you are over the rate limit. "
 			  "Please wait 10 seconds and try again."));
 		aim_conn_setlatency(fr->conn, windowsize/2);
@@ -1789,9 +1789,9 @@
 
 		case 0x0007: { /* Someone has denied you authorization */
-			imc_log(sess->aux_data, "The user %u has denied your request to add them to your contact list for the following reason:\n%s", msg->sender, msg->msg ? msg->msg : _("No reason given.") );
+			imcb_log(sess->aux_data, "The user %u has denied your request to add them to your contact list for the following reason:\n%s", msg->sender, msg->msg ? msg->msg : _("No reason given.") );
 		} break;
 
 		case 0x0008: { /* Someone has granted you authorization */
-			imc_log(sess->aux_data, "The user %u has granted your request to add them to your contact list for the following reason:\n%s", msg->sender, msg->msg ? msg->msg : _("No reason given.") );
+			imcb_log(sess->aux_data, "The user %u has granted your request to add them to your contact list for the following reason:\n%s", msg->sender, msg->msg ? msg->msg : _("No reason given.") );
 		} break;
 
@@ -1906,5 +1906,5 @@
 
 	if (od->rights.maxawaymsglen == 0)
-		imc_error(ic, "oscar_set_away_aim called before locate rights received");
+		imcb_error(ic, "oscar_set_away_aim called before locate rights received");
 
 	aim_setextstatus(od->sess, od->conn, AIM_ICQ_STATE_NORMAL);
@@ -1920,5 +1920,5 @@
 
 	if (strlen(message) > od->rights.maxawaymsglen) {
-		imc_error(ic, "Maximum away message length of %d bytes exceeded, truncating", od->rights.maxawaymsglen);
+		imcb_error(ic, "Maximum away message length of %d bytes exceeded, truncating", od->rights.maxawaymsglen);
 	}
 
@@ -2084,5 +2084,5 @@
 	
 	/* Now that we have a buddy list, we can tell BitlBee that we're online. */
-	imc_connected(ic);
+	imcb_connected(ic);
 	
 	return 1;
@@ -2106,5 +2106,5 @@
 		{
 			/* Hmm, the length should be even... */
-			imc_error( sess->aux_data, "Received SSI ACK package with non-even length");
+			imcb_error( sess->aux_data, "Received SSI ACK package with non-even length");
 			return( 0 );
 		}
@@ -2117,5 +2117,5 @@
 			if( st == 0x0E )
 			{
-				imc_log( sess->aux_data, "Buddy %s can't be added without authorization, requesting authorization", list );
+				imcb_log( sess->aux_data, "Buddy %s can't be added without authorization, requesting authorization", list );
 				
 				aim_ssi_auth_request( sess, fr->conn, list, "" );
@@ -2303,5 +2303,5 @@
         }
 
-		imc_log(ic, "%s\n%s", _("User Info"), str->str);
+		imcb_log(ic, "%s\n%s", _("User Info"), str->str);
         g_string_free(str, TRUE);
 
@@ -2397,16 +2397,16 @@
 			idletime.tm_sec = 0;
 			strftime(buff, 256, _("%d days %H hours %M minutes"), &idletime);
-			imc_log(ic, "%s: %s", _("Idle Time"), buff);
+			imcb_log(ic, "%s: %s", _("Idle Time"), buff);
 		}
 		
 		if(text) {
 			utf8 = oscar_encoding_to_utf8(extracted_encoding, text, text_length);
-			imc_log(ic, "%s\n%s", _("User Info"), utf8);
+			imcb_log(ic, "%s\n%s", _("User Info"), utf8);
 		} else {
-			imc_log(ic, _("No user info available."));
+			imcb_log(ic, _("No user info available."));
 		}
 	} else if(infotype == AIM_GETINFO_AWAYMESSAGE && userinfo->flags & AIM_FLAG_AWAY) {
 		utf8 = oscar_encoding_to_utf8(extracted_encoding, text, text_length);
-		imc_log(ic, "%s\n%s", _("Away Message"), utf8);
+		imcb_log(ic, "%s\n%s", _("Away Message"), utf8);
 	}
 
Index: protocols/oscar/rxqueue.c
===================================================================
--- protocols/oscar/rxqueue.c	(revision c2fb38096ea4e75a680e57e103d4a4986aa84c75)
+++ protocols/oscar/rxqueue.c	(revision 84b045d409f1e8da6d8bf379c6fef7236dcd9bcd)
@@ -392,5 +392,5 @@
 		aim_bstream_rewind(&flaphdr);
 		start = aimbs_get8(&flaphdr);
-		imc_error(sess->aux_data, "FLAP framing disrupted");
+		imcb_error(sess->aux_data, "FLAP framing disrupted");
 		aim_conn_close(conn);
 		return -1;
Index: protocols/oscar/search.c
===================================================================
--- protocols/oscar/search.c	(revision c2fb38096ea4e75a680e57e103d4a4986aa84c75)
+++ protocols/oscar/search.c	(revision 84b045d409f1e8da6d8bf379c6fef7236dcd9bcd)
@@ -39,5 +39,5 @@
 	/* XXX the modules interface should have already retrieved this for us */
 	if (!(snac2 = aim_remsnac(sess, snac->id))) {
-		imc_error(sess->aux_data, "couldn't get snac");
+		imcb_error(sess->aux_data, "couldn't get snac");
 		return 0;
 	}
Index: protocols/oscar/service.c
===================================================================
--- protocols/oscar/service.c	(revision c2fb38096ea4e75a680e57e103d4a4986aa84c75)
+++ protocols/oscar/service.c	(revision 84b045d409f1e8da6d8bf379c6fef7236dcd9bcd)
@@ -567,5 +567,5 @@
 		group = aimbs_get16(bs);
 
-		imc_error(sess->aux_data, "bifurcated migration unsupported");
+		imcb_error(sess->aux_data, "bifurcated migration unsupported");
 	}
 
@@ -894,5 +894,5 @@
 */
 		} else
-			imc_error(sess->aux_data, "WARNING: unknown hash request");
+			imcb_error(sess->aux_data, "WARNING: unknown hash request");
 
 	}
Index: protocols/oscar/txqueue.c
===================================================================
--- protocols/oscar/txqueue.c	(revision c2fb38096ea4e75a680e57e103d4a4986aa84c75)
+++ protocols/oscar/txqueue.c	(revision 84b045d409f1e8da6d8bf379c6fef7236dcd9bcd)
@@ -30,5 +30,5 @@
 
 	if (!conn) {
-		imc_error(sess->aux_data, "no connection specified");
+		imcb_error(sess->aux_data, "no connection specified");
 		return NULL;
 	}
@@ -46,5 +46,5 @@
 
 	} else 
-		imc_error(sess->aux_data, "unknown framing");
+		imcb_error(sess->aux_data, "unknown framing");
 
 	if (datalen > 0) {
@@ -80,5 +80,5 @@
 
 	if (!fr->conn) {
-		imc_error(sess->aux_data, "WARNING: enqueueing packet with no connection");
+		imcb_error(sess->aux_data, "WARNING: enqueueing packet with no connection");
 		fr->conn = aim_getconn_type(sess, AIM_CONN_TYPE_BOS);
 	}
@@ -120,5 +120,5 @@
 
 	if (!fr->conn) {
-		imc_error(sess->aux_data, "packet has no connection");
+		imcb_error(sess->aux_data, "packet has no connection");
 		aim_frame_destroy(fr);
 		return 0;