Index: doc/CHANGES
===================================================================
--- doc/CHANGES	(revision 73dd021fa884bae857685e9a1beb44948c03399a)
+++ doc/CHANGES	(revision 86fd261eb78c78dc6f2deba206f70471ebc07c73)
@@ -429,5 +429,5 @@
   officially be treated as case sensitive.
 - Fully stripping spaces from AIM screennames, this didn't happen completely
-  which severly breaks the IRC protocol.
+  which severely breaks the IRC protocol.
 - Removed all the yellow tape around daemon mode, it's pretty mature by now:
   testing.bitlbee.org serves all (~30) SSL users from one daemon mode
@@ -629,5 +629,5 @@
   some situations.
 - Outgoing MSN typing notifications are now understood correctly by the
-  orignal MS Mac/Windows clients (again).
+  original MS Mac/Windows clients (again).
 - Added "account add $protocol" to the documentation, got rid of a lot
   of over-markup (i.e. overuse of bold-tags), reviewed some other parts.
Index: doc/HACKING
===================================================================
--- doc/HACKING	(revision 73dd021fa884bae857685e9a1beb44948c03399a)
+++ doc/HACKING	(revision 86fd261eb78c78dc6f2deba206f70471ebc07c73)
@@ -14,5 +14,5 @@
 calls and arguments where that seemed useful, etc.
 
-However, up to late in the 1.2 series, the IRC core was still spread accross
+However, up to late in the 1.2 series, the IRC core was still spread across
 several files, mostly irc.c + irc_commands.c and pieces and bits in
 nogaim.c. If you're looking for a textbook example of layer violation, start
Index: doc/user-guide/Installation.xml
===================================================================
--- doc/user-guide/Installation.xml	(revision 73dd021fa884bae857685e9a1beb44948c03399a)
+++ doc/user-guide/Installation.xml	(revision 86fd261eb78c78dc6f2deba206f70471ebc07c73)
@@ -73,5 +73,5 @@
 <para>
 By default, BitlBee runs as the user nobody. You might want 
-to run it as a seperate user (some computers run named or apache as nobody). 
+to run it as a separate user (some computers run named or apache as nobody). 
 </para>
 
Index: doc/user-guide/commands.xml
===================================================================
--- doc/user-guide/commands.xml	(revision 73dd021fa884bae857685e9a1beb44948c03399a)
+++ doc/user-guide/commands.xml	(revision 86fd261eb78c78dc6f2deba206f70471ebc07c73)
@@ -182,5 +182,5 @@
 				
 				<para>
-					For more infomation about a setting, see <emphasis>help set &lt;setting&gt;</emphasis>.
+					For more information about a setting, see <emphasis>help set &lt;setting&gt;</emphasis>.
 				</para>
 				
@@ -240,5 +240,5 @@
 				
 				<para>
-					For more infomation about a setting, see <emphasis>help set &lt;setting&gt;</emphasis>.
+					For more information about a setting, see <emphasis>help set &lt;setting&gt;</emphasis>.
 				</para>
 				
@@ -1891,5 +1891,5 @@
 
 			<description>
-				<para>Rejects all incoming (not already transferring) file transfers. Since you probably have only one incoming transfer at a time, no id is neccessary. Or is it?</para>
+				<para>Rejects all incoming (not already transferring) file transfers. Since you probably have only one incoming transfer at a time, no id is necessary. Or is it?</para>
 			</description>
 
Index: doc/user-guide/misc.xml
===================================================================
--- doc/user-guide/misc.xml	(revision 73dd021fa884bae857685e9a1beb44948c03399a)
+++ doc/user-guide/misc.xml	(revision 86fd261eb78c78dc6f2deba206f70471ebc07c73)
@@ -90,5 +90,5 @@
 
 <para>
-Away states have different names accross different protocols. BitlBee will try to pick the best available option for every connection:
+Away states have different names across different protocols. BitlBee will try to pick the best available option for every connection:
 </para>
 
@@ -146,5 +146,5 @@
 
 <para>
-Control channels are where you see your contacts. By default, you will have one control channel called &amp;bitlbee, containing all your contacts. But you can create more, if you want, and divide your contact list accross several channels.
+Control channels are where you see your contacts. By default, you will have one control channel called &amp;bitlbee, containing all your contacts. But you can create more, if you want, and divide your contact list across several channels.
 </para>
 