Index: doc/user-guide/Makefile
===================================================================
--- doc/user-guide/Makefile	(revision 75a4b85ea060c5b63e9742ee9d1591bd618ba5c2)
+++ doc/user-guide/Makefile	(revision 89a180978d3e5d81300b82923e8a208ee085d754)
@@ -28,5 +28,5 @@
 	xsltproc --xinclude --output $@ docbook.xsl $< 
 
-help.txt: help.xml help.xsl
+help.txt: help.xml help.xsl commands.xml misc.xml quickstart.xml
 	xsltproc --stringparam extraparanewline "$(EXTRAPARANEWLINE)" --xinclude help.xsl $< | perl -0077 -pe 's/\n\n%/\n%/s; s/_b_/\002/g;' > $@
 
Index: doc/user-guide/commands.xml
===================================================================
--- doc/user-guide/commands.xml	(revision 75a4b85ea060c5b63e9742ee9d1591bd618ba5c2)
+++ doc/user-guide/commands.xml	(revision 89a180978d3e5d81300b82923e8a208ee085d754)
@@ -296,6 +296,6 @@
 	</bitlbee-command>
 
-	<bitlbee-setting name="auto_connect" type="boolean">
-		<default>True</default>
+	<bitlbee-setting name="auto_connect" type="boolean" scope="both">
+		<default>true</default>
 
 		<description>
@@ -310,6 +310,6 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="auto_reconnect" type="boolean">
-		<default>False</default>
+	<bitlbee-setting name="auto_reconnect" type="boolean" scope="both">
+		<default>false</default>
 
 		<description>
@@ -321,9 +321,12 @@
 				See also the <emphasis>auto_reconnect_delay</emphasis> setting.
 			</para>
-		</description>
-
-	</bitlbee-setting>
-
-	<bitlbee-setting name="auto_reconnect_delay" type="integer">
+
+			<para>
+				This setting can also be changed for specific accounts using the <emphasis>account set</emphasis> command. (However, these values will be ignored if the global <emphasis>auto_reconnect</emphasis> setting is disabled!)
+			</para>
+		</description>
+	</bitlbee-setting>
+
+	<bitlbee-setting name="auto_reconnect_delay" type="integer" scope="global">
 		<default>300</default>
 
@@ -339,6 +342,6 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="away_devoice" type="boolean">
-		<default>True</default>
+	<bitlbee-setting name="away_devoice" type="boolean" scope="global">
+		<default>true</default>
 
 		<description>
@@ -349,6 +352,6 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="buddy_sendbuffer" type="boolean">
-		<default>False</default>
+	<bitlbee-setting name="buddy_sendbuffer" type="boolean" scope="global">
+		<default>false</default>
 
 		<description>
@@ -367,5 +370,5 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="buddy_sendbuffer_delay" type="integer">
+	<bitlbee-setting name="buddy_sendbuffer_delay" type="integer" scope="global">
 		<default>200</default>
 
@@ -382,5 +385,5 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="charset" type="string">
+	<bitlbee-setting name="charset" type="string" scope="global">
 		<default>iso8859-1</default>
 		<possible-values>you can get a list of all possible values by doing 'iconv -l' in a shell</possible-values>
@@ -398,6 +401,6 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="debug" type="boolean">
-		<default>False</default>
+	<bitlbee-setting name="debug" type="boolean" scope="global">
+		<default>false</default>
 
 		<description>
@@ -408,5 +411,5 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="default_target" type="string">
+	<bitlbee-setting name="default_target" type="string" scope="global">
 		<default>root</default>
 		<possible-values>root, last</possible-values>
@@ -419,5 +422,5 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="display_name" type="string">
+	<bitlbee-setting name="display_name" type="string" scope="account">
 		<description>
 			<para>
@@ -427,6 +430,6 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="display_namechanges" type="boolean">
-		<default>False</default>
+	<bitlbee-setting name="display_namechanges" type="boolean" scope="global">
+		<default>false</default>
 
 		<para>
@@ -435,5 +438,5 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="handle_unknown" type="string">
+	<bitlbee-setting name="handle_unknown" type="string" scope="global">
 		<default>root</default>
 		<possible-values>root, add, add_private, add_channel, ignore</possible-values>
@@ -462,6 +465,6 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="lcnicks" type="boolean">
-		<default>True</default>
+	<bitlbee-setting name="lcnicks" type="boolean" scope="global">
+		<default>true</default>
 
 		<description>
@@ -473,5 +476,5 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="ops" type="string">
+	<bitlbee-setting name="ops" type="string" scope="global">
 		<default>both</default>
 		<possible-values>both, root, user, none</possible-values>
@@ -488,5 +491,5 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="password" type="string">
+	<bitlbee-setting name="password" type="string" scope="both">
 		<description>
 			<para>
@@ -504,5 +507,5 @@
 	</bitlbee-setting>
 	
-	<bitlbee-setting name="port" type="integer">
+	<bitlbee-setting name="port" type="integer" scope="account">
 		<description>
 			<para>
@@ -512,6 +515,6 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="private" type="boolean">
-		<default>True</default>
+	<bitlbee-setting name="private" type="boolean" scope="global">
+		<default>true</default>
 
 		<description>
@@ -526,5 +529,5 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="query_order" type="string">
+	<bitlbee-setting name="query_order" type="string" scope="global">
 		<default>lifo</default>
 		<possible-values>lifo, fifo</possible-values>
@@ -541,5 +544,5 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="resource" type="string">
+	<bitlbee-setting name="resource" type="string" scope="account">
 		<default>BitlBee</default>
 
@@ -551,6 +554,6 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="save_on_quit" type="boolean">
-		<default>True</default>
+	<bitlbee-setting name="save_on_quit" type="boolean" scope="global">
+		<default>true</default>
 
 		<description>
@@ -561,5 +564,5 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="server" type="string">
+	<bitlbee-setting name="server" type="string" scope="account">
 		<description>
 			<para>
@@ -569,6 +572,6 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="ssl" type="boolean">
-		<default>False</default>
+	<bitlbee-setting name="ssl" type="boolean" scope="account">
+		<default>false</default>
 
 		<description>
@@ -579,6 +582,6 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="strip_html" type="boolean">
-		<default>True</default>
+	<bitlbee-setting name="strip_html" type="boolean" scope="global">
+		<default>true</default>
 
 		<description>
@@ -592,5 +595,5 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="to_char" type="string">
+	<bitlbee-setting name="to_char" type="string" scope="global">
 		<default>": "</default>
 
@@ -606,6 +609,6 @@
 	</bitlbee-setting>
 
-	<bitlbee-setting name="typing_notice" type="boolean">
-		<default>False</default>
+	<bitlbee-setting name="typing_notice" type="boolean" scope="global">
+		<default>false</default>
 
 		<description>
Index: doc/user-guide/help.xsl
===================================================================
--- doc/user-guide/help.xsl	(revision 75a4b85ea060c5b63e9742ee9d1591bd618ba5c2)
+++ doc/user-guide/help.xsl	(revision 89a180978d3e5d81300b82923e8a208ee085d754)
@@ -58,5 +58,8 @@
 			<xsl:text>?set </xsl:text><xsl:value-of select="@name"/><xsl:text>&#10;</xsl:text>
 			<xsl:text>_b_Type:_b_ </xsl:text><xsl:value-of select="@type"/><xsl:text>&#10;</xsl:text>
-			<xsl:text>_b_Default:_b_ </xsl:text><xsl:value-of select="default"/><xsl:text>&#10;</xsl:text>
+			<xsl:text>_b_Scope:_b_ </xsl:text><xsl:value-of select="@scope"/><xsl:text>&#10;</xsl:text>
+			<xsl:if test="default">
+				<xsl:text>_b_Default:_b_ </xsl:text><xsl:value-of select="default"/><xsl:text>&#10;</xsl:text>
+			</xsl:if>
 			<xsl:if test="possible-values">
 				<xsl:text>_b_Possible Values:_b_ </xsl:text><xsl:value-of select="possible-values"/><xsl:text>&#10;</xsl:text>